using System;

class Linija()
{
    public int L;
    public int R;
}
class Program
{

    static void Main()
    {
        string[] input = Console.ReadLine().Split(' ');
        int N = Convert.ToInt32( input[0]);
        int Q = Convert.ToInt32( input[1]);
        //int[][] = 
        Linija[] Linije = new Linija[Q];
        char[] s = Console.ReadLine().ToCharArray();
        for (int i = 0; i < Q; i++) {
            input = Console.ReadLine().Split(' ');
            Linije[i]= new Linija();
            Linije[i].L = Convert.ToInt32( input[0]);
            Linije[i].R = Convert.ToInt32( input[1]);

        }

        for (int i = 0; i < Q; i++) {
            //int prev = s[Linije[i].L];
            if (i < Linije[i].L - Linije[i].R / 2)
            {
                s[i] = '6';
            }
            else
            {
                s[i] = '7';
            }
            if (Linije[i].L - Linije[i].R % 2 == 1)
            {
                Console.WriteLine((Linije[i].L - Linije[i].R + 1) * 2);


            }
            else {
                Console.WriteLine(Linije[i].L - Linije[i].R);
            }
                
        }


    }
}